function [averagePyramid, vecAveragePyramid] = createAveragePyramid(textonMap,K,L)

[numPixY, numPixX] = size(textonMap);
    
averagePyramid = cell(1,L);
vecAveragePyramid = [];
numBin = 4^(L-1);
numBinPerDim = sqrt(numBin);
numPixXPerBin = floor(numPixX/numBinPerDim);
numPixYPerBin = floor(numPixY/numBinPerDim);
x = zeros(numBin,K);
for row = 1:numBinPerDim
    for col = 1:numBinPerDim
        xBin = zeros(numPixXPerBin*numPixYPerBin,K);
        for j = 1:numPixXPerBin
            for i = 1:numPixYPerBin
                pixX =(col-1)*numPixXPerBin+j;
                pixY =(row-1)*numPixYPerBin+i;
                xBin((j-1)*numPixYPerBin+i,textonMap(pixY,pixX)) = 1;
            end
        end
        x((row-1)*numBinPerDim + col,:) = mean(xBin,1);
    end
end
vecAveragePyramid = x;
averagePyramid{1} = x;


for m = 2:L
    el = L-m+1;
    numBin = 4^(el-1);
    numBinPerDim = sqrt(numBin);
    x = zeros(numBin,K);
    xPrev = averagePyramid{m-1};
    for b = 1:numBin
        col = 2*(mod((b-1),numBinPerDim)+1);
        row = 2*(floor((b-1)/numBinPerDim+1));
        indices = zeros(1,4);
        indices(1) = (row-1)*2*numBinPerDim + col;
        indices(2) = indices(1) - 1;
        indices(3) = (row-1-1)*2*numBinPerDim + col;
        indices(4) = indices(3) - 1;
        x(b,:) = mean(xPrev(indices,:),1);
    end
    vecAveragePyramid = [vecAveragePyramid; x];
    averagePyramid{m} = x;
end

vecAveragePyramid = vecAveragePyramid';
vecAveragePyramid = vecAveragePyramid(:);

