function [filterBank, TextonLibrary] = createTextonLibrary(alpha,K,train)

if nargin < 3
    alpha = 300;
    K = 25;
    load('data.mat');
end

filterBank = createFilterBank();
numTypes = size(filterBank,2);
numFilters = 0;
for i = 1:numTypes
    if(i==1)
        numFilters = numFilters + 3*size(filterBank{i},2);
    else
        numFilters = numFilters + size(filterBank{i},2);
    end
end

tic;
disp('Starting Texton Library Generation...');
picPaths = train.files;
numPics = size(picPaths,2);
GiantFeatureMatrix = zeros(numPics*alpha, numFilters);
for i = 1:numPics
    I = imread(['data/',picPaths{i}]);
    IResponses = extractFilterResponses(I,filterBank);
    selectedPixels = randperm(size(IResponses,1));
    GiantFeatureMatrix((i-1)*alpha + 1 : i*alpha,:) = IResponses(selectedPixels(1:alpha),:);
    if(mod(i,ceil(numPics/20))==0)
        disp([num2str(round(i/numPics*100)),'%']);
    end
end
disp('Texton Library Generated.');
toc;

tic
disp('Starting kmeans...');
[res, TextonLibrary] = kmeans(GiantFeatureMatrix,K,'EmptyAction','drop');
disp('kmeans finished');
toc

