function filterResponses = extractFilterResponses(I,filterBank)

plot = 0;

[L,a,b] = RGB2Lab(double(I));
Lab = cell(1,3);
Lab{1} = L;
Lab{2} = a;
Lab{3} = b;

numTypes = size(filterBank,2);
numFilters = 0;
for i = 1:numTypes
    if(i==1)
        numFilters = numFilters + 3*size(filterBank{i},2);
    else
        numFilters = numFilters + size(filterBank{i},2);
    end
end

numPixX = size(I,2);
numPixY = size(I,1);
filterResponses = zeros(numPixX*numPixY, numFilters);

filterNum = 0;
if(plot)
    figure(1);
    clf;
    subplot(2,1,1), imshow(I);
end
for t = 1:numTypes
    aType = filterBank{t};
    for f = 1:size(aType,2)
        if(t == 1)
            %Gaussian Filter on L, a, and b
            for chan = 1:3
                filterNum = filterNum + 1;
                I2 = conv2(Lab{chan},aType{f},'same');
                filterResponses(:, filterNum) = I2(:);
                if(plot)
                    subplot(2,1,2), imshow(uint8(I2));
                    pause;
                end
            end
        else
            %LoG and DoG on L only
            filterNum = filterNum + 1;
            I2 = conv2(Lab{1},aType{f},'same');
            filterResponses(:, filterNum) = I2(:);
            if(plot)
                subplot(2,1,2), imshow(uint8(I2));
                pause;
            end
        end
    end
end

