tic
picPaths = test.files;
picClasses = test.labels;
numPics = size(picPaths,2);
H = K/3*(4^L-1);
TestHistograms = zeros(numPics,H);
TestClasses = zeros(numPics,1);
for i = 1:numPics
    disp([num2str(i),' of ',num2str(numPics),': ',picPaths{i}]);
    TestClasses(i) = picClasses{i};
    I = imread(['data/',picPaths{i}]);
    [textonMap, textonHisto] = textonify(I, filterBank, TextonLibrary);
    [averagePyramid, vecAveragePyramid] = createAveragePyramid(textonMap,K,L);
    TestHistograms(i,:) = vecAveragePyramid;
    if plot
        [numPixY, numPixX, numChan] = size(I);
        figure(1);
        clf;
        subplot(2,1,1), imshow(I);
        subplot(2,1,2), imagesc(textonMap/25);
        colormap(jet);
        axis equal;
        axis([0,numPixX,0,numPixY]);
        figure(2);
        clf;
        bar(textonHisto);
        if(i<numPics)
            pause;
        end
    end
end
toc

save('TestHistograms.mat', 'TestHistograms');
save('TestClasses.mat', 'TestClasses');
disp('Test data saved.');
