function [TestClasses, predictedTestClasses] = sceneCategorize()

load 'TrainHistograms.mat'
load 'TrainClasses.mat'
load 'TestHistograms.mat'
load 'TestClasses.mat'
numTest = size(TestClasses,1);

predictedTestClasses = zeros(numTest,1);
for i = 1:numTest
    predictedTestClasses(i) = categorizeScene(TrainHistograms, TrainClasses, TestHistograms(i,:));
end

function aClass = categorizeScene(TrainHistograms, TrainClasses, TestHistogram)
numTrain = size(TrainClasses,1);
minMetric = compareScenes(TrainHistograms(1,:), TestHistogram);
minMetricIndex = 1;
for T = 2:numTrain
    aMetric = compareScenes(TrainHistograms(T,:), TestHistogram);
    if(aMetric < minMetric)
        minMetric = aMetric;
        minMetricIndex = T;
    end
end
aClass = TrainClasses(minMetricIndex);

function aMetric = compareScenes(TrainHistogram, TestHistogram)
aMetric = chiSquareDist(TrainHistogram, TestHistogram);
