function [textonMap, textonHisto] = textonify(I, filterBank, TextonLibrary)

plot = 0;

[numPixY, numPixX, numChan] = size(I);

IResponses = extractFilterResponses(I,filterBank);
numPix = size(IResponses,1);

K = size(TextonLibrary,1);

textonMap = zeros(numPixY,numPixX);
for i = 1:numPix
    dists = distSqr(IResponses(i,:)', TextonLibrary(1:K,:)');
    [minDist, minIndex] = min(dists);
    textonMap(i) = minIndex(1);
end
textonHisto = hist(textonMap(:),K)/(numPixX*numPixY);

if(plot)
    figure(1);
    clf;
    subplot(2,1,1), imshow(I);
    subplot(2,1,2), imagesc(textonMap/25);
    colormap(jet);
    axis equal;
    axis([0,numPixX,0,numPixY]);
    figure(2);
    clf;
    bar(textonHisto);
    pause;
end